

#include "vpixcon.h"


/* ***********************************************************
*********************************************************** */
int pcam_ai::clamp_tunneling(double *x, double *y, double *z) {

   vector4d start, end, midpt;
   vector3d ray;
   vector4d pos, normal;
   double limit = 1000000.0;

   if (!terrain_tree)
      return 0;

   start[0] = *x;
   start[1] = *y;
   start[2] = 1000000.0;
   start[3] = 1.0;
   
   end[0] = *x;
   end[1] = *y;
   end[2] = -1000000.0;
   end[3] = 1.0;
   
   midpt[0] = *x;
   midpt[1] = *y;
   midpt[2] = 0;
   midpt[3] = 1.0;
   
   ray[0] = 0;
   ray[1] = 0;
   ray[2] = -1;
   
   if (point_terrain_collision(terrain_tree, NULL, start, end, midpt, &limit, ray, pos, normal)) {
      *z = pos[2] + 2;
      return 1;
   }

   return 0;   
}


/* ***********************************************************
   adjust camera so that its 2 units above terrain at least
*********************************************************** */
int pcam_ai::nix_tunneling(double *x, double *y, double *z) {

   double tz;

   tz = *z;

   if (clamp_tunneling(x, y, &tz) && ((attach_object && !(attach_object->platform_flag & PLATFORM_FLAG_FLY)) || *z < tz)) {
      *z = tz;
      return 1;
   }

   return 0;   
}

