

#include "matrix.h"
#include "smailbox.h"
#include "dataio.h"


/* ******************************************************************
****************************************************************** */
class smessage_type : public message_type {

   public:
      int type;
      virtual ~smessage_type() {}
};


/* ******************************************************************
****************************************************************** */
void spost_office_type::update_mailboxes() {

   mailbox_type *ptr;
   smessage_type *btr;
   buffer_type buffer;
   sfile sbuffer;
   int type;
   int size;

   for (ptr = (mailbox_type *)mailbox_list.head; ptr; ptr = (mailbox_type *)ptr->next)
      while (ptr->mailslot->query_message_raw(&buffer, 8)) {
         sbuffer.scan_data(&buffer);
         type = sbuffer.scan_int();
         size = sbuffer.scan_int();
         if (ptr->mailslot->receive_message_raw(&buffer, size)) {
            message_list.append(btr = new smessage_type, NULL);
            btr->buffer.buffercpy(&buffer);
            btr->type = type;
         }

      }

}


/* ******************************************************************
****************************************************************** */
int spost_office_type::find_message(int type, buffer_type *buffer) {

   smessage_type *ptr;

   update_mailboxes();

   if (!message_list.head)
      return 0;

   for (ptr=(smessage_type *)message_list.head; ptr; ptr=(smessage_type *)ptr->next)
      if (ptr->type == type) {
         message_list.remove(ptr);
         buffer->buffercpy(&ptr->buffer);
         delete ptr;
         return 1; 
      }

   return 0;
}


/* ******************************************************************
****************************************************************** */
int spost_office_type::send_message(buffer_type *buffer) {

   if (!mailbox_list.head)
      return 0;

   ((mailbox_type *)mailbox_list.head)->mailslot->send_message_raw(buffer);
   return 1;
}

